//
//  AppDelegate.m
//  BMKMultiRoutePlanDemo
//
//  Created by v_zhangbaojin on 2020/5/26.
//  Copyright © 2020 zhangbaojin. All rights reserved.
//

#import "AppDelegate.h"
#import "MainTableViewController.h"
#import "BMKNavigationController.h"
#import "BNaviService.h"

//导航开放平台注册
#define BNAVI_APP_KEY       @"UbtVytisuW1KOUxpldLXuBneDR3ebQjS"
//语音开放平台注册
#define TTS_APP_ID          @"16402543"
#define TTS_API_KEY         @"UbtVytisuW1KOUxpldLXuBneDR3ebQjS"
#define TTS_SECRET_KEY      @"cWWYQG6YGqMByWxM1zhtxD3wDlU0IYlz"


@interface AppDelegate ()<BNNaviSoundDelegate>

@end

@implementation AppDelegate
#pragma mark - BNNaviSoundDelegate
- (void)onPlayTTS:(NSString *)text {
    NSLog(@"onPlayTTS text = %@", text);

}

- (void)onPlayVoiceSound:(BNVoiceSoundType)type filePath:(NSString *)filePath {
    NSLog(@"onPlayTTS type = %i，filePath = %@", type, filePath);

}

- (void)onTTSAuthorized:(BOOL)success {
    
}


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
       MainTableViewController *rootVC = [MainTableViewController new];
       BMKNavigationController *navigationController = [[BMKNavigationController alloc] initWithRootViewController:rootVC];
       UIWindow *rootWindow = [UIWindow new];
       self.window = rootWindow;
       [self.window setRootViewController:navigationController];
       self.window.backgroundColor = [UIColor whiteColor];
       [self.window makeKeyAndVisible];
    
    
    [BNaviService_Instance initNaviService:nil success:^{
         [BNaviService_Instance authorizeNaviAppKey:BNAVI_APP_KEY
                                         completion:^(BOOL suc) {
                                             NSLog(@"authorizeNaviAppKey ret = %d", suc);
                                         }];
         [BNaviService_Instance authorizeTTSAppId:TTS_APP_ID
                                           apiKey:TTS_API_KEY
                                        secretKey:TTS_SECRET_KEY
                                       completion:^(BOOL suc) {
                                           NSLog(@"authorizeTTS ret = %d", suc);
                                       }];
         [BNaviService_Sound setSoundDelegate:self];
     } fail:^{
         NSLog(@"initNaviSDK fail");
     }];
    return YES;
}


@end
