//
//  MainTableViewController.m
//  PodTest
//
//  Created by zhangbaojin on 2019/11/20.
//  Copyright © 2019 zhangbaojin. All rights reserved.
//

#import "MainTableViewController.h"

@interface MainTableViewController ()

@property (nonatomic, copy) NSArray *functionList;

@end

@implementation MainTableViewController


- (void)viewDidLoad {
    [super viewDidLoad];
    [self setupUI];
}

- (void)setupUI {
    self.title = @"多路线规划";

    UIBarButtonItem *backBarButtonItem = [[UIBarButtonItem alloc] init];
    backBarButtonItem.title = @"返回";
    self.navigationItem.backBarButtonItem = backBarButtonItem;
    self.tableView.autoresizingMask = UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth;
    self.tableView.separatorInset = UIEdgeInsetsZero;
}

#pragma mark - Table view data source

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
   return self.functionList.count;
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
   static NSString *CellIdentifier = @"BMKFunctionListCell";
       UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
       if (!cell) {
           cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier];
           cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
           cell.textLabel.font = [UIFont boldSystemFontOfSize:24];
       }
       cell.textLabel.text = self.functionList[indexPath.row][@"title"];
       cell.detailTextLabel.text = self.functionList[indexPath.row][@"detail"];
       return cell;
}

-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    return 60;
}

-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    NSString *className = self.functionList[indexPath.row][@"className"];
    UIViewController *subVC = [[NSClassFromString(className) alloc] init];
    subVC.title = self.functionList[indexPath.row][@"title"];
    [self.navigationController pushViewController:subVC animated:YES];
}

- (NSArray *)functionList {
    if (_functionList == nil) {
        NSString *name = [[NSBundle mainBundle] pathForResource:@"functionName.json" ofType:nil];
        NSData *data = [NSData dataWithContentsOfFile:name];
        _functionList = [NSJSONSerialization JSONObjectWithData:data options:0 error:nil];
    }
    return _functionList;
}

@end
