# 百度地图导航SDK

本工程为基于百度导航iOS导航SDK进行封装，实现了路线规划多路线展示及切换。

## 功能描述  ##
基于基于百度导航iOS导航SDK进行封装，实现了路线规划多路线展示。开发者可根据自身  需求自定义BMKMultiRouteSelectedView文件。

## 导航SDK集成 ##
参考：[百度地图开放平台](http://lbsyun.baidu.com/index.php?title=ios-navsdk/guide/projectConfiguration)

## 核心类/接口 ##
| 类   | 接口  | 说明   | 版本   |
| -----|:-----:|:-----:|:------:| 
| BMKMultiRouteSelectedView | --- | 自定义的路线选中框, 实现多路线的切换效果 | --- |
| -----| - (void)configData:(NSArray<BNCarOneRouteModel *> *)routes | 配置路线数据 | --- |
| -----| - (void)multiRouteSelected:(NSUInteger)index; | 设置选中第几条route | --- |
| -----| - (void)routeSelected:(void(^)(NSUInteger index))selectedBlock; | 方案选中回调 | --- |
| BNaviService | - (void)startNaviRoutePlan:(BNRoutePlanMode)eMode naviNodes:(NSArray*)naviNodes time:(BNaviCalcRouteTime*)naviTime delegete:(id<BNNaviRoutePlanDelegate>)delegate userInfo:(NSDictionary*)userInfo | 发起算路 | --- |
| -----| - (void)routePlanDidFinished:(NSDictionary*)userInfo; | 算路成功回调 | --- |
| -----| - (void)routePlanDidFailedWithError:(NSError *)error andUserInfo:(NSDictionary*)userInfo; | 算路失败回调 | --- |
| -----| -(void)routePlanDidUserCanceled:(NSDictionary*)userInfo; | 算路取消回调 | --- |
| -----| - (void)onHandleTouchRouteAtIndex:(NSUInteger)routeIndex; |用户在地图上点击了某条路线回调 | --- |

## 核心难点 ##

`Objective-C`

```
/** 发起算路. */
- (void)startRoutePlan {
    if (self.nodes.count >= 2) {
        BNaviService_RoutePlan.disableOpenUrl = YES;
        [BNaviService_RoutePlan startNaviRoutePlan:BNRoutePlanMode_Recommend naviNodes:self.nodes time:nil delegete:self userInfo:nil];
    }
}
/** 屏幕适配. */
- (void)showRouteViewAll {
    BNMargin margin = {80, 20, CGRectGetHeight(self.view.frame) - (KScreenHeight-[self bottomPaneHeight]-(kRAButtonHeight*2+1)-5), 20};
    [BNaviService_DriveRoute showRouteViewAll:margin animated:YES];
}
#pragma mark - BNNaviRoutePlanDelegate
/**  算路成功回调. */
- (void)routePlanDidFinished:(NSDictionary*)userInfo {
    NSLog(@"算路成功回调 = %@", userInfo);
    [self showRouteViewAll];
    [self initMapSubView];
    BNCarRouteModel *route = userInfo[BNDriveRouteDataKey];
    if (route) {
        self.carRoute = route;
    }
    // 配置路线数据
    [self.multiRouteView configData:self.carRoute.carRoutes];
    // 默认选中第一条
    [self.multiRouteView multiRouteSelected:0];
    
    // 路线选中回调
    __weak typeof(self) weakSelf = self;
    [self.multiRouteView routeSelected:^(NSUInteger index) {
        [weakSelf routeSelectIndex:index needSelectRoute:YES];
    }];
}
```
